#ifndef _CELLSPACE_H_NOU_
#define _CELLSPACE_H_NOU_

#include <GL/gl.h>
#include <CL/cl.h>
#include <iostream>
#include <map>
#include <string>

using namespace std;

class Model;

typedef union
{
    float f;
    int i;
    unsigned int ui;
    long long l;
    unsigned long long ul;
    double d;
}Variant;

class CellSpace
{
    private:
    cl_mem space;
    cl_mem tex;
    GLuint gl_texture;
    int width,height;
    int which;//executiva bude prebiehat na zaklade striedania sa bufferov
    Model *parent;
    map<string, Variant> values;
    public:
    CellSpace(Model *parent, int w, int h);
    ~CellSpace();
    void run(int iteration = 1);
    Model* getParent(){ return parent; }
    cl_mem* getSpace(){ return &space; }
    int getWidth(){ return width; }
    int getHeight(){ return height; }
    void setValue(string key, Variant v);
    Variant getValue(string key);
    void renderToTexture();
    void setGLTexture(GLuint texture);
    /**
    nahraje do buffera raw data ktore su ulozene v buffery-
    @param size velkost dat v data.
    @param data pointer na data. ocakava ze tam bude width*heigh*cellsize. prekopruje sa minimum(size , w*h*cellsize)
    */
    void loadData(size_t size, void *data);
    protected:
};

#endif // _CELLSPACE_H_NOU_
