#ifndef _CELLULAMAINWINDOW_H_NOU_
#define _CELLULAMAINWINDOW_H_NOU_

#include <QApplication>
#include <QMainWindow>
#include <QToolBar>
#include <QAction>
#include <QCleanlooksStyle>
#include <QMdiArea>
#include  <QDir>
#include "glwidget.h"
#include "options.h"
#include "newstatedialog.h"
#include "newmodeldialog.h"

class CellulaMainWindow : public QMainWindow
{
    Q_OBJECT
    private:
    QToolBar *main_toolbar, *record_toolbar;
    QAction *actionRun,*actionPause,*actionStop;
    QAction *actionOpen,*actionNew,*actionNewState,*actionSave,*actionSaveImage,*actionQuit,*actionOption,*actionLoadRLE;
    QAction *actionTile,*actionCascade;
    QAction *actionStartRecording, *actionStopRecording;
    QGLWidget *gl_widget;
    Options *option_dialog;
    NewStateDialog *newstatedialog;
    NewModelDialog *newmodeldialog;
    Machine *machine;
    QMdiArea *mdi;
    QDockWidget *log, *lua_console;
    Model *model,*asyn_model;
    void createMenu();
    void createAction();
    void createToolbar();
    void createDock();
    void translateGUI();
    public:
    CellulaMainWindow();
    ~CellulaMainWindow();
    public slots:
    void showOptionDialog();
    void createCLMachine();
    void startSimulation();
    void stopSimulation();
    void newModel();
    void newState();
    void createNewState(int width, int height);
    void createNewModel(int type, QString name);
    void loadRLE();
    void save();
    void load();
    void saveImage();
};

#endif // _CELLULAMAINWINDOW_H_NOU_
