#ifndef LUACONSOLE_H
#define LUACONSOLE_H

#include <QTextEdit>
#include <iostream>
#include <vector>
#include <sstream>
#include <string>
extern "C"
{
    #include <lua5.1/lualib.h>
    #include <lua5.1/lauxlib.h>
}

using namespace std;

class LuaConsole : public QTextEdit
{
    public:
    LuaConsole(QWidget * parent = 0);
    LuaConsole(const QString & text, QWidget * parent = 0);
    ~LuaConsole();
    protected:
    void keyPressEvent(QKeyEvent *e);
    void execute();
    void historyKey(int key);
    static int luaPrint(lua_State *L);
    void luaPrint(string s);
    private:
    void init();
    lua_State *Lstate;
    vector<QString> history;
    int history_index;
    //protected slot:
    //void moveCursorToEnd();
};

#endif // LUACONSOLE_H
