#include "newmodeldialog.h"
#include <QGridLayout>
#include <QLabel>
#include <QMessageBox>
#include <QDialogButtonBox>

NewModelDialog::NewModelDialog(QWidget *parent) : QDialog(parent)
{
    QGridLayout *grid_layout = new QGridLayout(this);
    QDialogButtonBox *ok_button = new QDialogButtonBox(QDialogButtonBox::Ok | QDialogButtonBox::Cancel);
    connect(ok_button, SIGNAL(accepted()), this, SLOT(accept()));
    connect(ok_button, SIGNAL(rejected()), this, SLOT(reject()));

    QLabel *type_label = new QLabel(trUtf8("Typ modelu"), this);
    model_type = new QComboBox(this);
    model_type->addItem(trUtf8("Synchrónny model"));
    model_type->addItem(trUtf8("Asynchrónny model"));

    QLabel *name_label = new QLabel(trUtf8("Názov modelu"), this);
    name = new QLineEdit(this);

    grid_layout->addWidget(type_label, 0, 0);
    grid_layout->addWidget(model_type, 0, 1);
    grid_layout->addWidget(name_label, 1, 0);
    grid_layout->addWidget(name, 1, 1);
    grid_layout->addWidget(ok_button, 2, 1);
}

void NewModelDialog::accept()
{
    if(name->text().isEmpty())QMessageBox::information(this, trUtf8("Chýba názov"), trUtf8("Chýba názov modelu. Zadajte nejaký názov."));
    else
    {
        emit createNewModel(model_type->currentIndex(), name->text());
        name->setText("");
        QDialog::accept();
    }
}

void NewModelDialog::reject()
{
    name->setText("");
    QDialog::reject();
}
