#ifndef _OPTIONS_H_NOU_
#define _OPTIONS_H_NOU_

#include <QDialog>
#include <QDialogButtonBox>
#include <QComboBox>
#include <QTabWidget>
#include <QVBoxLayout>
#include <QStackedWidget>
#include <QSettings>
#include <QSpinBox>
#include <QCheckBox>
#include "machine.h"
#include "clutility.h"

class Options : public QDialog
{
    Q_OBJECT
    public:
    Options(QWidget *parent);
    ~Options();
    void accept();
    void reject();
    cl_device_v getDevices();
    int getPlatform(){ return platforms->currentIndex(); }
    bool useCLGLInteroperability();
    protected:
    private:
    QDialogButtonBox *ok_cancel;
    QTabWidget *tabs;
    QWidget *opencl;
    QVBoxLayout *vertical_layout;
    QComboBox *platforms;
    QStackedWidget *platform_stack;
    QCheckBox *cl_gl_interoperablity;
    QSettings settings;
    void createOpenCL();
};

#endif // _OPTIONS_H_NOU_
