#ifndef _TEXTEDITOR_H_NOU_
#define _TEXTEDITOR_H_NOU_

#include <QTextEdit>
#include <QTextDocument>
#include <QSyntaxHighlighter>
#include <QFile>
#include "subwindowinterface.h"
#include "model.h"

class Hightligter : public QSyntaxHighlighter
{
    struct HightlightingRule
    {
        QRegExp pattern;
        QTextCharFormat format;
    };
    QVector<HightlightingRule> rules;

    public:
    Hightligter(QTextDocument *document);
    void highlightBlock(const QString &text);
};

class TextEditor : public QTextEdit, public SubWindowInterface
{
    Q_OBJECT
    Hightligter *highlighter;
    QTextDocument document;
    QFile *fr;
    QString modelName;
    static int number;
    Model *model;
    public:
    /**
    Konstruktor ktory vytvori okno na definiciu modelu a aj samotny model.
    @param text definicia modelu.
    @param model model
    */
    TextEditor(const QString &text, Model *model, QWidget *parent = 0);
    ~TextEditor();
    static int getUntitledNumber(){ return number++; }
    QString getName(){ return modelName; }
    void setName(const QString &name);
    int compile(QTextEdit *log = 0);
    //SubWindowInterface metody
    void setSubWindowTitle();
    int load(const QString &file);
    QString save(const QString &dir);
    QString getFileName();
    Model* getModel(){ return model; }
    protected:
    void closeEvent(QCloseEvent *event);
};

#endif // _TEXTEDITOR_H_NOU_
